
! salir.h 0.2 completamente beta
! Puertas y localidades con movimiento alternativo a cardinales
!
! (c) 2005 Enrique D. Bosch 'Presi' (http://aventuras.presi.org)
! con licencia LGPL
!
!    This library is free software; you can redistribute it and/or
!    modify it under the terms of the GNU Lesser General Public
!    License as published by the Free Software Foundation; either
!    version 2.1 of the License, or (at your option) any later version.
!
!    This library is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
!    Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with this library; if not, write to the Free Software
!    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!    Una copia de esta licencia se puede obtener en 
!    http://www.gnu.org/licenses/lgpl.html
!
! AVISO: Esta librera est en fase muy temprana de desarrollo y aun se le 
! podran hacer modificaciones que hicieran incompatible el uso de versiones 
! posteriores.


class ss_msg
  with
    no_entrar_cerrada "No puedes entrar ahi, la puerta est cerrada.",
    no_salir_cerrada "No puedes salir por ahi, la puerta est cerrada.",
    no_salir_por "No puedes salir por ahi.",
    no_salir_a "No puedes salir ahi.",
    no_salir_varias "Hay ms de una salida.",
  ;

#ifndef SS_MENSAJES;
ss_msg ss_mensajes_por_defecto;
constant SS_MENSAJES=ss_mensajes_por_defecto;
#endif;


class ss_habitacion    ! clase principal de una localidad
  with
   salida 0,
   antes
    [padre;
    
       salir: padre=parent(jugador);
              if (padre==localizacion || (localizacion==laoscuridad && padre==localizacion_real))
                {
                  if (self.salida)
                    {
                       if (metaclass(self.salida)==routine) return self.salida();
                       self.salida.salir_meterse=true;
                       <<meterse self.salida>>;
                    }
                  return ImprimirOEjecutar(SS_MENSAJES,no_salir_varias,0);
                }
              return false;
    ],
  has luz
  ;


class ss_puerta           ! puertas de las localidades
  with
    antes
     [;
        meterse,
        salirpor,
        salirA  : if (self hasnt abierto)
                    if (accion==##meterse && ~~self.salir_meterse) 
                         return ImprimirOEjecutar(SS_MENSAJES,no_entrar_cerrada,0);
                    else
                      {
                         ImprimirOEjecutar(SS_MENSAJES,no_salir_cerrada,0);
                         self.salir_meterse=false;
                         return true;
                      }
                  if (~~ImprimirOEjecutar(self,mensaje,0)) return true;
                  jugadorA(self.donde_lleva,2);
                  return true;
     ],
    despues
     [;
        abrir:  give self.otro_lado abierta;
        cerrar: give self.otro_lado ~abierta;
     ],
    salir_meterse false,
  has abrible femenino
   ;


class ss_umbral     ! es un paso sin puerta
  with
    antes
     [;
        meterse,
        salirpor,
        salirA  : if (~~ImprimirOEjecutar(self,mensaje,0)) return true;
                  jugadorA(self.donde_lleva,2);
                  return true;
     ],
  ;


class ss_localidad    ! objeto complementario a la localidad (para poder ser nombrada)
  with
    descripcion
     [; <<mirar>>; ],
    antes
     [; salirse: <<salir>>; ],
  has escenario
  ;
